interface AsyncLoopProgression {
    index: number;
    params: any;
    currentExecutionCount: number;
}
interface AsyncLoopProgressionStop<RETURN_TYPE> extends AsyncLoopProgression {
    result: RETURN_TYPE;
}
type AsyncLoopProgressionOnStart = (data: AsyncLoopProgression) => void;
type AsyncLoopProgressionOnStop<RETURN_TYPE> = (data: AsyncLoopProgressionStop<RETURN_TYPE>) => void;
interface MakeAsyncLoopOptions<RETURN_TYPE> {
    waitingDuration?: number;
    maxExecution?: number;
    onStart?: AsyncLoopProgressionOnStart;
    onStop?: AsyncLoopProgressionOnStop<RETURN_TYPE>;
}

declare const makeAsyncLoop: <RETURN_TYPE>(callback: (...parameters: any[]) => Promise<RETURN_TYPE>, options?: MakeAsyncLoopOptions<RETURN_TYPE> | undefined) => (...parameters: any[]) => Promise<RETURN_TYPE[]>;

export { type AsyncLoopProgression, type AsyncLoopProgressionOnStart, type AsyncLoopProgressionOnStop, type AsyncLoopProgressionStop, type MakeAsyncLoopOptions, makeAsyncLoop };
